#!/bin/bash
# This script tries to convert from the orginal charset to another charset
# It finds every text files, and convert it.
# Author : Raphael Berlamont
# Licence : As-IS

SEARCH_DIR=.
FILES_TO_FIND="*"
TYPE_OF_FILE="f"
TMP_DIR=/tmp
# File that contains all files
FICHIER_TEMPORAIRE="${TMP_DIR}/convert_to_utf8-`cat /dev/urandom | uuencode -m - | head -2 | tail -1 | cut -b1-20 | sed "s/[^0-9a-zA-Z]//g" | cut -b1-5`.tmp"
#convert tool must exist
if [ `which recode >/dev/null 2>&1; echo $?` -eq 0 ]
then
	RECODE_TOOL=`which recode`
else
	echo "Can't find recode tool in $PATH. Please install it (ou may find it on the GNU site and launch this script again."
	exit 1
fi
# Stream Editor must exist
which sed 2>&1 >/dev/null
if [ `which sed >/dev/null 2>&1; echo $?` -eq "0" ]
then
	SED=`which sed`
else
	echo "Can't find sed (Stream Editor) in $PATH. Please install it and launch this script again."
	exit 1
fi

# Destination charset
NEW_CHARSET=UTF-8


#################
# MAIN		#
#################
find ${SEARCH_DIR} -name "${FILES_TO_FIND}" -exec file -i {} \;  | grep charset >> ${FICHIER_TEMPORAIRE}
while read line
do
	FILE_TO_TREAT="`echo $line | cut -d":" -f1`"
	FILE_OWNER="`stat -c "%U" ${FILE_TO_TREAT}`"
	FILE_GROUP="`stat -c "%G" ${FILE_TO_TREAT}`"
	FILE_ENCODING="`echo "$line"|sed "s/.* charset=\(.*\)[ ;]*.*/\1/"`"
	${RECODE_TOOL} ${FILE_ENCODING}..${NEW_CHARSET} ${FILE_TO_TREAT}
	chown ${FILE_OWNER}:${FILE_GROUP} ${FILE_TO_TREAT}
done < ${FICHIER_TEMPORAIRE}

#################
# CLEANING	#
#################
#rm ${FICHIER_TEMPORAIRE}

find . -type f -exec sed -i "s/charset=iso-8859-1/charset=utf-8/" {} \;
