<?
/*
    parser_log.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Frdric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

include (dirname(__FILE__)."/../include/config.php");

# pour la gestion des TimePeriod
# (correction du bug #49)
# on utilise Naupy !!!
include (dirname(__FILE__)."/../include/naupy.inc.php");

$nagios = new Nagios;
$nagios->ParseConfigFile(_PATH_NAGIOS_CFG);


function give_state($etat) {
	if ($etat == "CRITICAL") {
		$state = 8;
	} else if ($etat == "WARNING") {
		$state = 7;
	} else if ($etat == "UNKNOWN") {
		$state = 6;
	} else if ($etat == "PENDING") {
		$state = 2;
	} else {
		$state = 1;
	}
	return $state;
}


$host_downtime = array();

function set_host_downtime($host_downtime, $host, $downtime){
  # echo "\n $host : $downtime \n<br>";
  $host_downtime["$host"] = $downtime;
  return $host_downtime;
}

function host_is_in_downtime($host_downtime, $host){
  # echo "$host : ". $host_downtime["$host"] ." \n<br>";
  return ( $host_downtime["$host"] > 0);
}

function service_is_in_downtime($host_downtime, $host, $service, $downtime) {
 # echo "\n$host, $service, $downtime " . (host_is_in_downtime($host_downtime, $host) || ($downtime > 0))." fin \n<br>";
 return ( host_is_in_downtime($host_downtime, $host) || ($downtime > 0) );
}

#function service_is_not_checked($nagios,$host, $service_name) {
#  global $jour;
#  global $heure;
#  $services = $nagios->GetHostServices($host);
#  foreach ($services as $service_test) {
#    if ($service_test['service_description'] == $service_name ) {
#      $tp_name = give_timeperiod_name($nagios, $service_test);
#      $tp = give_time_period_value($nagios, $tp_name);
#      
#      $tp_hour_str = $tp[$jour];
#      if ( !isset($tp_hour_str) ) {
#        return TRUE;
#      }
#      else {
#        $tp_hours = explode(',',$tp_hour_str);
#        $ok = FALSE;
#        foreach ($tp_hours as $tp_hour) {
#          $hours = explode('-',$tp_hour);
#          if ( ($heure >= $hours[0]) && ($heure <= $hours[1])) {
#            $ok = TRUE;
#          } 
#        }
#        return $ok;
#      }
#    }
#  }
#return FALSE;
#}



// on parse le fichier de statut et on met a jour le champ statut pour les host et etat pour les services
$f=fopen(_DIR_STATUS, "r");
// tant qu'y en a on lit une ligne
while ($ligne = fgets($f, 20048)) {
	if (strstr($ligne, "HOST")) {
		$log = explode(";", $ligne);
                $host_downtime = set_host_downtime( $host_downtime, $log["1"],$log["17"]);
		mysql_query("update hosts set statut='".$log["2"]."' where name='".$log["1"]."'");
	}
	else if (strstr($ligne, "SERVICE")) {
		$log = explode(";", $ligne);
		if ($log["5"] == "SOFT") {
			$etat = give_state($log["3"]);
		} else {
			$etat = give_state($log["14"]);
		}

                if (!$nagios->service_is_in_check_period($log["1"],$log["2"])) {
                  $SQL = " , not_checked = 1 ";
                }
                    else {
                      $SQL = " , not_checked = 0 ";
                    }

                if (service_is_in_downtime($host_downtime, $log["1"], $log["2"], $log["27"])) {
                  # echo "\nHOST ".$log["1"]." service ".$log["2"]." is in downtime\n";
                  $SQL .= " , downtime = 1 ";
                }
                else { 
                  # echo "\nHOST ".$log["1"]." service ".$log["2"]." is NOT in downtime\n";
                  $SQL .= " , downtime = 0 ";
                }

		if (strstr($log["3"], "PENDING")) { $etat = give_state($log["3"]); }
		$ackeur = "";
		if (($log["13"] == 1) && ( $etat >= 6)) {
			$etat -= 3;
			// on parse le fichier comment.log afin de recuperer le nom du ackeur
			$f2=fopen(_DIR_COMMENT, "r");
			// tant qu'y en a on lit une ligne
			while ($ligne = fgets($f2, 1024)) {
				if (strstr($ligne, "ACKNOWLEDGEMENT") && strstr($ligne, $log["1"]) && strstr($ligne, $log["2"])) {
					$comment = explode(";", $ligne);
					$ackeur = $comment["5"];
				}
			}
			fclose($f2);
		}
# echo "select id from services where name='".$log["2"]."'<br>";
		$services_id = mysql_fetch_array(mysql_query("select id from services where name='".$log["2"]."'"));
		$host_id = mysql_fetch_array(mysql_query("select id from hosts where name = '".$log["1"]."'"));
                #echo "update l_services_hosts set " .
                #  "etat='".$etat."', " .
                #  "ackeur='".$ackeur."' " .
                #  $SQL .
                #  "where id_services='".$services_id["id"]."' " .
                #  "and id_hosts='".$host_id["id"]."'\n<br>";
		mysql_query("update l_services_hosts set " .
				"etat='".$etat."', " .
				"ackeur='".$ackeur."' " .
			        $SQL .
				"where id_services='".$services_id["id"]."' " .
				"and id_hosts='".$host_id["id"]."'");
		$boite_id = mysql_fetch_array(mysql_query("select id from boite where name = '".$log["1"]."'"));
		# echo "update l_boite_services set etat='".$etat."', ackeur='".$ackeur."' $SQL where id_services='".$services_id["id"]."' and id_host='".$host_id["id"]."'\n\n<br>";
		mysql_query("update l_boite_services set etat='".$etat."', ackeur='".$ackeur."' $SQL where id_services='".$services_id["id"]."' and id_host='".$host_id["id"]."'");
	}
}
fclose($f);

# ALTER TABLE `l_services_hosts` ADD `downtime` TINYINT( 2 ) DEFAULT '0' NOT NULL ;
# ALTER TABLE `l_boite_services` ADD `downtime` TINYINT( 2 ) DEFAULT '0' NOT NULL ;
echo "Parsage fini!<br><br>"
?>
<input type="button" value="Fermer" onClick="window.close();">